/*
 * fragment.h
 *
 * Copyright 2022 Jonathan Schöbel <jonathan@Ubermos-2019>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#ifndef _FRAGMENT_H
#define _FRAGMENT_H

#include "data.h"


struct SH_Fragment
{
	struct SH_Data * data;
	char * tag;
};

struct SH_Fragment * SH_Fragment_new (const char * tag,
				      struct SH_Data * data,
				      struct SH_Error * error);
void SH_Fragment_free (struct SH_Fragment * fragment,
		       struct SH_Error * error);

char * SH_Fragment_get_tag (struct SH_Fragment * fragment,
			    struct SH_Error * error);

#endif /* _FRAGMENT_H */
